// FILENAME:	Siege_Blister_Point.cs
//
// DESIGNER:      Temujin
//
// BASED ON:      CMer02 (campaign map) and WAR_martian_standoff
//------------------------------------------------------------------------------

$missionName = "SIEGE_Blister_Point";
$server::HudMapViewOffsetX = -2750;
$server::HudMapViewOffsetY = 960;

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("siege.cs");

$shieldgens = 4;

// Herc X/Y coordinates must be defined for where they respawn.
// HeavyHercs == 1 & 2, LightHercs == 3 & 4, Tanks == 5 & 6
$Herc1X = -2400;
$Herc1Y = 1310;
$Herc2X = -3100;
$Herc2Y = 610;
$Herc3X = -2200;
$Herc3Y = 410;
$Herc4X = -3300;
$Herc4Y = 1510;
$Herc5X = -3050;
$Herc5Y = 960;
$Herc6X = -2750;
$Herc6Y = 660;

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to " @ $missionName @ "!  SIEGE is a one-way WAR map.  Please read the <F6>?<F0> tab now.");
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
   marsSounds();

   initGlobalVars();
}

/////////////////////////////////////////////////////////////////////////////////////////////
// Deus Protection code - Heals DI after each attack if shields are still active...
//                        A hack yes, but an effective one.
/////////////////////////////////////////////////////////////////////////////////////////////

function DI::structure::onAttacked(%attacked,%attacker)
{
   if($shieldgens < 1) {
	healObject(%attacked, 10000);
   }
}

/////////////////////////////////////////////////////////////////////////////////////////////
// Shield Gen Code
/////////////////////////////////////////////////////////////////////////////////////////////

function ShieldGen::structure::onDestroyed( %this, %who )
{
   $shieldgens -= 1;
   if($shieldgens < 1) {
      %player = playerManager::vehicleIdToPlayerNum( %who );
      %txt = "The last Shield Generator has been destroyed. The Deus Irae is unprotected!";
      say(IDSTR_TEAM_BLUE, 1234, "<F5>ATTENTION: " @ %txt @ "<F0>",  "ene_struct_dest.wav");    
      say(IDSTR_TEAM_RED, 1234, "<F5>WARNING: " @ %txt @ "<F0>", "friend_struct_des.wav");
      lowerfields(39);  
   }
   else {
      %player = playerManager::vehicleIdToPlayerNum( %who );
      %txt = "A Shield Generator has been destroyed. Only " @ $shieldgens @ " remaining.";
      say(IDSTR_TEAM_BLUE, 1234, "<F5>ATTENTION: " @ %txt @ "<F0>",  "ene_struct_dest.wav");    
      say(IDSTR_TEAM_RED, 1234, "<F5>WARNING: " @ %txt @ "<F0>", "friend_struct_des.wav");    
   }
}

function lowerfields(%height)
{
   %newheight = %height - 0.25;

   %field = getObjectId("MissionGroup\\RED\\Field1");
   lower( %height, %field );   

   %field = getObjectId("MissionGroup\\RED\\Field2");
   lower( %height, %field );

   %field = getObjectId("MissionGroup\\RED\\Field3");
   lower90( %height, %field );   

   %field = getObjectId("MissionGroup\\RED\\Field4");
   lower90( %height, %field );

   if(%newheight > -50) 
      schedule("lowerfields(" @ %newheight @ ");", 0.1);
}

function lower( %z, %field )
{
   %x = getPosition(%field,x);
   %y = getPosition(%field,y);

   setPosition(%field, %x, %y, %z, 0, 180);
}

function lower90( %z, %field )
{
   %x = getPosition(%field,x);
   %y = getPosition(%field,y);

   setPosition(%field, %x, %y, %z, 90, 180);
}

// Mission Cleanup...

function onMissionEnd()
{
deleteObject("MissionGroup\\Hercs");
deleteObject("MissionGroup\\RED");
deleteObject("MissionGroup");
deleteObject("MissionCleanup");

deleteFunctions("lower*");

deleteVariables("$shieldgens");
}